{=======================================================================================================================

  Comming Library

       .

========================================================================================================================

  :

  12.05.2019 [*] SaveDescriptIon:   D7.
  10.05.2019 [*] SaveDescriptIon:  .
  20.04.2019 [*] RecurseDir:    .* .
  04.04.2019 [*] SaveDescriptIon:    .
  03.04.2019 [+] SaveDescriptIon:   .
  02.04.2019 [+] ExtractFilePathTree:   ,   .
  24.10.2018 [*] RecurseDir:   .
  06.11.2017 [*] GetVolumeNo, GetVolumeSerialNumber:  Integer  DWORD.
  20.12.2016 [+] ExtractDirectoryName:       .
  20.03.2015 [+] RecurseDirectory:   .
  15.03.2015 [+] UniqueTagFile:    (34 ).
  13.03.2015 [*] GetVolumeName:     .
  17.09.2014 [!]   D7  XE.
  16.09.2014 [!]  Comming D7  XE.
  10.05.2014 [+] RecurseDir:      .
  09.03.2013 [*] .
  15.11.2011 [*] ReplaceFileLine:    .
  02.09.2011 [*] RecurseDir:     .
  10.06.2011 [*] RecurseDir:       .
  05.01.2011 [*] GetVolumeNo, GetVolumeSerialNumber:   UNC  .
  26.09.2010 [*] NormalFileName:   .
  25.07.2010 [*] ExtractFileNameNoExt:   .
  05.07.2010 [+]  IStorage.
  03.07.2010 [*] ExtractFileNameNoExt:  .
  12.05.2010 [*] GetVolumeLetter:    GetVolumeInformation.
                 GetVolumeName:  .
  10.04.2010 [*] GetVolumeLetter: -  .
  09.10.2009 [*] TakeFileSize:  .
  29.09.2009 [+] NormalFileName:   .
  28.05.2008 [*] GetVolumeSerialNumber:     .
  22.05.2008 [+] GetVolumeSerialNumber:   .
  25.09.2007 [+] ExtractFilePathFormat:      .
  16.10.2006 [+] ExtractFilePathNameNoExt:     ,   .
  26.05.2006 [+] ZIPFile:    zip-.
  14.03.2005 [*] .
  28.11.2004 [*] ExtractFileNameNoExt:     .
  17.08.2004 [*] ReplaceFileLine:    ,   .
  16.08.2004 [+] ReplaceFileLine:    .
  11.09.2003 [*] TakeFileSize:    read-only .
  03.09.2003 [+] TakeFileSize:   .
  07.12.2002 [*] RecurseDir:  .
  31.07.2002 [*] GetDiskKind:  .
             [*] GetVolumeName:     .
  28.06.2002 [-] .
  04.06.2001 [+] GetVolumeName:   .
  10.05.2001 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982019 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingFile.pas,v 1.10 2019/05/12 09:31:52 tsk Exp $
=======================================================================================================================}
unit CommingFile;

interface

  uses  Windows, Classes, SysUtils, Forms, ShellAPI, ActiveX, AxCtrls, Graphics, Jpeg,
        {$IFDEF VER150} // D7
        ComObj,
        {$ELSE} // XE
        System.Win.ComObj,
        {$ENDIF}
        // Comming:
        CommingString;

type
  TShowPath = procedure ( Path: String ) of object;

  //     ()  :
  function    GetVolumeNo( Drive: String ): DWORD;
  //     ()  :
  function    GetVolumeSerialNumber( Drive: String ): String;
  //    ():
  function    GetVolumeName( Drive: String ): String;
  //    ()   :
  function    GetVolumeLetter( Name: String ): String;
  //   :
  function    GetDiskKind( Drive: Char ): Integer;
  //   :
  function    TakeFileSize( FileName: String ): Int64;
  //     :
  function    ExtractFileNameNoExt( FileName: String ): String;
  function    ExtractFileDirectory( FileName: String ): String;
  function    ExtractDirectoryName( PathName: String ): String;
  //     ,     :
  function    ExtractFilePathNameNoExt( FileName: String ): String;
  function    ExtractFilePathTree( FileName: String; First: Integer = 1; Last: Integer = MaxInt ): TStringList;
  //       Format.
  function    ExtractFilePathFormat( FileName: String ): String;
  //      :
  procedure   RecurseDir( PathInicial, Ext: String; var FileList: TStringList; Correct: String = ''; AShow: TShowPath = nil );
  //   :
  procedure   RecurseDirectory( PathInicial: String; var FileList: TStringList; Correct: String = '' );
  //   '/'   ,  :
  function    NormalDir( const DirName: String ): String;
  //   :
  function    NormalFileName( FileName: String ): String;
  //   :
  function    UniqueTagFile( FileName: String ): String;
  //    :
  procedure   ReplaceFileLine( FileName, SepBeg, SepEnd: String; Data: TStringList;
                               FileBlank: String = ''; New: Boolean = False  );
  //   pkzip25.
  procedure   ZIPFile( FileName: String );
  //   .
  procedure   SaveDescriptIon( PathName, Descript: String );

  //  IStorage.
  procedure   IStorageCreate( FileName: String );
  procedure   IStorageOpen( FileName: String );
  procedure   IStorageWrite( Name, Data: String ); overload;
  procedure   IStorageWrite( Name: String; Data: TGraphic ); overload;
  procedure   IStorageWrite( Name: String; Data: TStrings ); overload;
  function    IStorageReadString( Name: String ): String;
  function    IStorageReadGraphic( Name: String ): TGraphic;
  function    IStorageReadMemo( Name: String ): TStrings;
  procedure   IStorageClose;

resourcestring
  erNotSeparator = '  %s   %s';
  erNotFileBlank = '  %s   %s';
  erNotPath      = '  %s    ';

var StgFile: IStorage;

implementation
//======================================================================================================================
function GetVolumeNo( Drive: String ): DWORD;
  var V: Array[0..11] of Char;
      S: Array[0..5] of Char;
      N, M, I: DWORD;
begin
  if Length( Drive ) = 1 then Drive := Drive + ':\';
  GetVolumeInformation( PChar( Drive ), @V, MAX_PATH, @N, M, I, @S, 5 );
  Result := N;
end;
//======================================================================================================================
function GetVolumeSerialNumber( Drive: String ): String;
  var n: DWORD;
begin
  n := GetVolumeNo( Drive );
  Result := IntToHex( HiWord( n ), 4 ) + '-' + IntToHex( LoWord( n ), 4 )
end;
//======================================================================================================================
function GetVolumeName( Drive: String ): String;
  var VolumeName : array [0..MAX_PATH] of Char;
      na, nb, nc: DWORD;
begin
  Result := '';
  if GetVolumeInformation( PChar( Drive + ':\'), VolumeName, SizeOf(VolumeName), @na, nb, nc, nil, 0 )
    then Result := VolumeName;
end;
//======================================================================================================================
function GetVolumeLetter( Name: String ): String;
  var VolumeName : array [0..MAX_PATH] of Char;
      na, nb, nc: DWORD;
      i: Integer;
begin
  Result := '?';
  for i := 65 to 90 do
    if GetVolumeInformation( PChar( Char(i) + ':\'), VolumeName, SizeOf(VolumeName), @na, nb, nc, nil, 0 )
        and ( UpperCase( VolumeName ) = UpperCase( Name )) then Result := Char(i);
end;
//======================================================================================================================
function GetDiskKind( Drive: Char ): Integer;
begin
  Result := GetDriveType( PChar( Drive + ':\' ));
end;
//======================================================================================================================
function TakeFileSize( FileName: String ): Int64;
begin
  with TFileStream.Create( FileName, fmOpenRead or fmShareDenyWrite) do
    try
      Result := Size;
    finally
      Free;
    end;
end;
//======================================================================================================================
function ExtractFileNameNoExt( FileName: String ):String;
begin
  Result := ChangeFileExt( ExtractFileName( FileName ), '' );
end;
//======================================================================================================================
function ExtractFileDirectory( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName );
  if ( Length( Result ) >= 2 ) and ( Result[2] = ':' )
    then Result := Copy( Result, 3, Length( Result ) )
end;
//======================================================================================================================
function ExtractDirectoryName( PathName: String ): String;
begin
  Result := ExtractFileDir( PathName );
  while Pos( PathDelim, Result ) > 0 do Result := Copy( Result, Pos( PathDelim, Result ) + 1, MaxInt);
end;
//======================================================================================================================
function ExtractFilePathNameNoExt( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName ) + '\' + ExtractFileNameNoExt( FileName );
end;
//======================================================================================================================
function ExtractFilePathFormat( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName ) + '\%s.' + ExtractFileExt( FileName );
end;
//======================================================================================================================
function ExtractFilePathTree( FileName: String; First, Last: Integer ): TStringList;
  var p, c: Integer;
begin
  Result := TStringList.Create; c := 1;
  for p := 0 to Length( FileName ) do
    if Copy( FileName, p, 1 ) = '\' then begin
      if ( c >= First ) and ( c <= Last ) then Result.Add( Copy( FileName, 1, p ));
      Inc( c );
    end;
end;
//======================================================================================================================
procedure RecurseDir( PathInicial, Ext: String; var FileList: TStringList; Correct: String; AShow: TShowPath );
  var SearchRec: TSearchRec;
      Result: Integer;
begin
  if Assigned( AShow ) then AShow( PathInicial + '...' );
  Result := FindFirst( PathInicial + '*.*', faAnyFile, SearchRec);
  while Result = 0 do begin
    if ( SearchRec.Name <> '.' ) and ( SearchRec.Name <> '..' )
                                                    and ( not IncludeDataString( SearchRec.Name, Correct )) then begin
      //  :
      if ( SearchRec.Attr and faDirectory ) > 0 then begin
        //  :
        RecurseDir( PathInicial + SearchRec.Name + '\', Ext, FileList, Correct, AShow )
      end else begin
        if ( UpperCase( ExtractFileExt( SearchRec.Name )) = '.' + UpperCase( Ext ))
          then FileList.Add( PathInicial + SearchRec.Name );
      end;
    end;
    Application.ProcessMessages;
    Result := FindNext( SearchRec );
  end;
  FindClose( SearchRec );
end;
//======================================================================================================================
procedure RecurseDirectory( PathInicial: String; var FileList: TStringList; Correct: String );
  var SearchRec: TSearchRec;
      Result: Integer;
begin
  Result := FindFirst( PathInicial + '*.*', faDirectory, SearchRec);
  while Result = 0 do begin
    if ( SearchRec.Name[1] <> '.' ) and ( Pos( Correct, SearchRec.Name ) = 0 ) then begin
      if ( SearchRec.Attr and faDirectory ) > 0 then begin
        FileList.Add( PathInicial + SearchRec.Name );
        //  :
        RecurseDirectory( PathInicial + SearchRec.Name + '\', FileList, Correct )
      end;
    end;
    Application.ProcessMessages;
    Result := FindNext( SearchRec );
  end;
  FindClose( SearchRec );
end;
//======================================================================================================================
function NormalDir( const DirName: String): String;
begin
  Result := DirName;
  if Result = EmptyStr then exit;
  if Result[ Length( Result )] <> '\' then Result := Result + '\';
end;
//======================================================================================================================
function NormalFileName( FileName: String ): String;
begin
  Result := DeleteChars( FileName, '<>"\/*:?|');
end;
//======================================================================================================================
function UniqueTagFile( FileName: String ): String;
  var buff: Longword;
      d: Int64;
begin
  with TFileStream.Create( FileName, fmOpenRead or fmShareDenyWrite) do
    try
      Result := IntToHex( Size, 10 );
      // RIFF 
      Position := 4;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
      // 1/4 
      d := round( Size / 4 );
      Position := d;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
      // 3/4 
      Position := Size - d;
      Read( buff, 4 );
      Result := Result + IntToHex( buff, 8 );
    finally
      Free;
    end;
end;
//======================================================================================================================
procedure ReplaceFileLine( FileName, SepBeg, SepEnd: String; Data: TStringList; FileBlank: String; New: Boolean );
  var Fil, Tmp: TStringList;
      i, j: Integer;
      Ins: Boolean;
begin
  Fil := TStringList.Create;
  Tmp := TStringList.Create;
  if FileExists( FileName ) and ( not New )
    then Fil.LoadFromFile( FileName )
    else if FileExists( FileBlank )
           then Fil.LoadFromFile( FileBlank )
           else raise EAbort.CreateFmt( erNotFileBlank, [ FileName, FileBlank ]);
  Ins := False;
  for i := 0 to Fil.Count - 1  do begin
    if ( Pos( SepBeg, Fil[i] ) > 0 ) then begin
      Tmp.Add( Fil[i] );
      for j := 0 to Data.Count - 1 do Tmp.Add( Data[j] );
      Ins := True;
    end else if ( Pos( SepEnd, Fil[i] ) > 0 ) then begin
      Tmp.Add( Fil[i] );
      Ins := False
    end else if not Ins then Tmp.Add( Fil [i] )
  end;
  if Ins then raise EAbort.CreateFmt( erNotSeparator, [ FileName, SepEnd ]);
  if not ForceDirectories( ExtractFilePath( FileName ))
    then raise EAbort.CreateFmt( erNotPath, [ FileName ]);
  Tmp.SaveToFile( FileName );
  Tmp.Free;
  Fil.Free;
end;
//======================================================================================================================
procedure ZIPFile( FileName: String );
  var sZIP: String;
begin
  sZIP := ChangeFileExt( FileName, '.zip');
  ShellExecute( Application.Handle, 'open', 'pkzip25',
                PChar( Format( ' -add -move "%s" "%s"', [ sZIP, FileName ])),
                nil, SW_SHOWNORMAL );
end;
//======================================================================================================================
procedure SaveDescriptIon( PathName, Descript: String );
  var des: TStringList;
      path, line: String;
      p: Integer;
      lp: Boolean;
  const DescriptFile = 'descript.ion';
begin
  path  := PathName;
  des   := TStringList.Create;
  if Copy( path, Length( path ), 1 ) = '\' then path := Copy( path, 1, Length( path ) - 1 );
  {$IFDEF VER150} // D7
  line := StrToOem( Copy( path, PosLast( '\', path ) + 1, MaxInt ));
  {$ENDIF}
  path := Copy( path, 1, PosLast( '\', path ));
  FileSetAttr( path + DescriptFile, 0 );
  if FileExists( path + DescriptFile ) then des.LoadFromFile( path + DescriptFile );
  repeat
    lp := True;
    p := StringListPos( line, des );
    if p >= 0 then begin
      des.Delete( p );
      lp := False;
    end;
  until (lp);
  des.Add( '"' + line + '" ' + Descript );
  des.SaveToFile( path + DescriptFile );
  FileSetAttr( path + DescriptFile, faHidden or faArchive );
  des.Free;
end;
//======================================================================================================================
//  IStorage.
//======================================================================================================================
procedure IStorageCreate( FileName: String );
  var pFN: PWideChar;
begin
  pFN := StringToOleStr( FileName );
  StgCreateDocfile( pFN, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, StgFile );
end;
//======================================================================================================================
procedure IStorageOpen( FileName: String );
  var pFN: PWideChar;
begin
  pFN := StringToOleStr( FileName );
  StgOpenStorage( pFN, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, nil, 0, StgFile );
end;
//======================================================================================================================
procedure IStorageWrite( Name, Data: String );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    OLEStream.WriteBuffer( Pointer( Data )^, Length( Data ));
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
procedure IStorageWrite( Name: String; Data: TGraphic );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    Data.SaveToStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
procedure IStorageWrite( Name: String; Data: TStrings );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    Data.SaveToStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
function  IStorageReadString( Name: String ): String;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: String;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    SetLength( buff, OLEStream.Size );
    OLEStream.ReadBuffer( Pointer(buff)^, OLEStream.Size );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
function IStorageReadGraphic( Name: String ): TGraphic;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: TJPEGImage;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  buff := TJPEGImage.Create;
  try
    buff.LoadFromStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
function IStorageReadMemo( Name: String ): TStrings;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: TStringList;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  buff := TStringList.Create;
  try
    buff.LoadFromStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
procedure IStorageClose;
begin
  StgFile := nil;
end;
//======================================================================================================================
end.
