{===================================================================================================

  Comming Library.

     ToolBar2000.

====================================================================================================

  :

  01.05.2010 [*] TB2ExportMenu:    .
  28.09.2009 [+] TB2SortByCaption:    .
  29.06.2009 [+] TB2IndexByCaption:    .
  18.09.2002 [+]  Images  .
  11.09.2002 [+]  .
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982010 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingToolBar2000.pas,v 1.2 2017/08/26 08:41:50 tsk Exp $
===================================================================================================}
unit CommingToolBar2000;

interface

  uses TB2Item, Menus;

  procedure TB2ExportMenu( Item: TTBCustomItem; Menu: TMenu );
  function  TB2IndexByCaption( Item, SubItem: TTBCustomItem ): Integer;
  procedure TB2SortByCaption( Item: TTBCustomItem );

implementation
//==================================================================================================
procedure TB2ExportMenu( Item: TTBCustomItem; Menu: TMenu );

  procedure Recurse (MenuItem: TMenuItem; TBItem: TTBCustomItem);
  var
    I: Integer;
    Src: TMenuItem;
    IsSep, IsSubmenu: Boolean;
    Dst: TTBCustomItem;
    N: String;
  begin
    for I := 0 to MenuItem.Count-1 do begin
      Src := MenuItem[I];
      IsSep := (Src.Caption = '-');
      IsSubmenu := False;
      if not IsSep then begin
        if Src.Count > 0 then
          IsSubmenu := True;
        if not IsSubmenu then
          Dst := TTBItem.Create(TBItem.Owner)
        else
          Dst := TTBSubmenuItem.Create(TBItem.Owner);
        Dst.Action := Src.Action;
        Dst.Caption := Src.Caption;
        Dst.Checked := Src.Checked;
        Dst.Options := [tboShowHint];
        if Src.Default then
          Dst.Options := Dst.Options + [tboDefault];
        Dst.Enabled := Src.Enabled;
        Dst.Hint    := Src.Hint;
//        Dst.HelpContext := Src.HelpContext;
        Dst.Images     := Src.GetImageList;
        Dst.ImageIndex := Src.ImageIndex;
        Dst.ShortCut := Src.ShortCut;
//        {$IFDEF JR_D5}
        Dst.SubMenuImages := Src.SubMenuImages;
//        {$ENDIF}
        Dst.OnClick := Src.OnClick;
      end
      else begin
        Dst := TTBSeparatorItem.Create(TBItem.Owner);
      end;
      Dst.Hint := Src.Hint;
      Dst.Tag := Src.Tag;
      Dst.Visible := Src.Visible;
      if not IsSep then
        { Temporarily clear the menu item's OnClick property, so that renaming
          the menu item doesn't cause the function name to change }
        Src.OnClick := nil;
      try
        N := 'TB2Item_' + Src.Name;
//        Src.Name := N + '_OLD';
        Dst.Name := N;
      finally
        if not IsSep then
          Src.OnClick := Dst.OnClick;
      end;
      TBItem.Add( Dst );
      if IsSubmenu then Recurse( Src, Dst );
    end;
  end;

begin
  Item.Clear;
  Recurse (Menu.Items, Item);
end;
//==================================================================================================
function TB2IndexByCaption( Item, SubItem: TTBCustomItem ): Integer;
  var i: Integer;
begin
  Result := -1;
  for i := 0 to Item.Count -  1 do
    if ( Item[i].Caption = SubItem.Caption ) then begin
      Result := i;
      Exit;
    end;
end;
//==================================================================================================
procedure TB2SortByCaption( Item: TTBCustomItem );
  var i, j: Integer;
begin
  for j := 1 to Item.Count - 1 do
    for i := 0 to j - 1 do begin
      if Item[i+1].Caption < Item[i].Caption then Item.Move( i + 1, i);
    end;
end;
//==================================================================================================
end.
