{=======================================================================================================================

  Comming Library.  

     .

========================================================================================================================

  :

  13.07.2017 [*] SetProduct:   .
  28.01.2016 [+] GetVersionFile:     '000.000.0000000'.
  08.01.2016 [-] .
  31.12.2015 [!]    GetFileVersionInfo.
  21.07.2015 [+] GetVersionFile:     '0.0.0000000'.
  30.04.2015 [*]    -.
  15.04.2015 [*]        POS (D7  XE).
  11.04.2015 [+]    .
  31.03.2015 [*] GetBuildTime:  D7  XE.
  08.03.2015 [*] GetBuildTime:   .
  06.03.2015 [*] SetProduct:     .
  19.02.2015 [*] GetBuildTime:    ,   .
  09.03.2013 [*] .
  04.06.2013 [+] GetProduct:    .
  26.01.2012 [*] Delphi XE2
  20.07.2010 [*] GetBuildTime:  , -  .
  19.05.2010 [*] SetProduct:     .
  17.05.2010 [+] SetProduct:  .
  07.08.2002 [*]       .
  18.07.2002 [*]    GetVersion ( -).
  08.11.2001 [-]  TAB.
  29.01.2001 [+]  GetVersion (" ...  ...").
  09.01.2001 [+]  GetBuildTime (   ).
  13.12.2000 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982017 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingVersionInfo.pas,v 1.10 2017/07/13 01:56:00 tsk Exp $
=======================================================================================================================}
unit CommingVersionInfo;

interface

uses Windows, Forms, SysUtils, CommingFile,
     {$IFDEF VER150} // D7
     Registry;
     {$ELSE} // XE
     System.Win.Registry;
     {$ENDIF}

  // 
  function  GetVersion( Text: String = ' '{; New: Boolean = True }): String;
  function  GetVersionFile( FileName: String = '*'; Long: Boolean = False ): String;
  //    :
  function  GetBuildTime( FileName: String = '*'): TDateTime;
  //  .
  type TRegProduct = ( rpDate, rpVersion );
  procedure SetProduct;
  function  GetProduct( par: TRegProduct ): Variant;

  const EmptyVersionOld = '0.0.0.0';
        EmptyVersionNew = '0.0.0000000';
        EmptyVersionLong = '000.000.0000000';

implementation
//======================================================================================================================
function GetVersionFile( FileName: String; Long: Boolean ): String;
var
  Info: Pointer;
  InfoSize: DWORD;
  FileInfo: PVSFixedFileInfo;
  FileInfoSize: DWORD;
  Tmp: DWORD;
  EmptyVer: String;
begin
  if FileName = '*' then FileName := Application.ExeName;
  if Long then EmptyVer := EmptyVersionLong else EmptyVer := EmptyVersionNew;
  InfoSize := GetFileVersionInfoSize(PChar(FileName), Tmp);
  //     .
  if InfoSize = 0
    then Result := EmptyVersionNew
    else begin
      GetMem(Info, InfoSize);
      try
        GetFileVersionInfo(PChar(FileName), 0, InfoSize, Info);
        VerQueryValue(Info, '\', Pointer(FileInfo), FileInfoSize);
        if Long
          then Result := Format( '%.3d.%.3d.%.3d%.5d',  [ FileInfo.dwFileVersionMS shr 16,
                                                          FileInfo.dwFileVersionLS shr 16,
                                                          FileInfo.dwFileVersionMS and $FFFF,
                                                          FileInfo.dwFileVersionLS and $FFFF ])
          else Result := Format( '%d.%d.%.3d%.5d',      [ FileInfo.dwFileVersionMS shr 16,
                                                          FileInfo.dwFileVersionLS shr 16,
                                                          FileInfo.dwFileVersionMS and $FFFF,
                                                          FileInfo.dwFileVersionLS and $FFFF ]);
      finally
        FreeMem(Info, FileInfoSize);
      end;
    end;
end;
//======================================================================================================================
function GetVersion( Text: String{; New: Boolean }): String;
  var ver: String;
begin
  Result  := Text;
//  ver     := GetVersionInfo( New );
  ver     := GetVersionFile;
  if (ver[1] <> '0' ) then Result := Result + ver + '  ' + FormatDateTime( 'dd.mm.yyyy', GetBuildTime );;
end;
//======================================================================================================================
function GetBuildTime( FileName: String ): TDateTime;
type
  UShort = Word;
  TImageDosHeader = packed record
    e_magic: UShort;                //  
    e_cblp: UShort;                 //      
    e_cp: UShort;                   //   
    e_crlc: UShort;                 // Relocations
    e_cparhdr: UShort;              //    
    e_minalloc: UShort;             // Minimum extra paragraphsneeded
    e_maxalloc: UShort;             // Maximum extra paragraphsneeded
    e_ss: UShort;                   //  ()   SS
    e_sp: UShort;                   //   SP
    e_csum: UShort;                 //  
    e_ip: UShort;                   //    IP
    e_cs: UShort;                   //  ()   CS
    e_lfarlc: UShort;               //      
    e_ovno: UShort;                 //  
    e_res: array[0..3] of UShort;   // 
    e_oemid: UShort;                // OEM identifier (for e_oeminfo)
    e_oeminfo: UShort;              // OEM information; e_oemid specific
    e_res2: array[0..9] of UShort;  // 
    e_lfanew: LongInt;              //     .exe
  end;

  TImageResourceDirectory = packed record
    Characteristics: DWord;
    TimeDateStamp: DWord;
    MajorVersion: Word;
    MinorVersion: Word;
    NumberOfNamedEntries: Word;
    NumberOfIdEntries: Word;
    //  IMAGE_RESOURCE_DIRECTORY_ENTRY DirectoryEntries[];
  end;
  PImageResourceDirectory = ^TImageResourceDirectory;

var
  hExeFile: HFile;
  ImageDosHeader: TImageDosHeader;
  Signature: Cardinal;
  ImageFileHeader: TImageFileHeader;
  ImageOptionalHeader: TImageOptionalHeader;
  ImageSectionHeader: TImageSectionHeader;
  ImageResourceDirectory: TImageResourceDirectory;
  Temp: Cardinal;
  i: Integer;
begin
  if FileName = '*' then FileName := Application.ExeName;
  hExeFile := CreateFile( PChar( FileName ), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
  try
    ReadFile(hExeFile, ImageDosHeader, SizeOf(ImageDosHeader), Temp, nil);
    SetFilePointer(hExeFile, ImageDosHeader.e_lfanew, nil, FILE_BEGIN);
    ReadFile(hExeFile, Signature, SizeOf(Signature), Temp, nil);
    ReadFile(hExeFile, ImageFileHeader, SizeOf(ImageFileHeader), Temp, nil);
    ReadFile(hExeFile, ImageOptionalHeader, SizeOf(ImageOptionalHeader), Temp, nil);
    for i := 0 to ImageFileHeader.NumberOfSections - 1 do
      begin
        ReadFile(hExeFile, ImageSectionHeader, SizeOf(ImageSectionHeader), Temp, nil);
{$IFDEF VER150} // D7
        if StrComp(@ImageSectionHeader.Name, '.rsrc') = 0 then Break;
{$ELSE} // XE
        if StrComp(@ImageSectionHeader.Name, 'B.rsrc') = 0 then Break;
{$ENDIF}
      end;
    SetFilePointer(hExeFile, ImageSectionHeader.PointerToRawData, nil, FILE_BEGIN);
    ReadFile(hExeFile, ImageResourceDirectory, SizeOf(ImageResourceDirectory), Temp, nil);
  finally
    FileClose(hExeFile);
  end;
  if ImageResourceDirectory.TimeDateStamp > 0
    then Result := FileDateToDateTime( ImageResourceDirectory.TimeDateStamp )
{$IFDEF VER150} // D7
    else Result := FileAge( FileName );
{$ELSE} // XE
    else FileAge( FileName, Result );
{$ENDIF}
end;
//======================================================================================================================
procedure SetProduct;
  var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey( 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\' + Application.Title, True )
      and ( ReadString( 'DisplayVersion' ) < GetVersionFile {GetVersionInfo( True )}) then begin
        WriteString( 'Publisher', 'TSK Dev Lab');
        WriteString( 'DisplayName', Application.Title );
        WriteString( 'DisplayVersion', GetVersionFile {GetVersionInfo( True )});
        WriteString( 'InstallDate', FormatDateTime( 'yyyymmdd', Now()));
        WriteString( 'UninstallString', 'rundll32 user32.dll,MessageBoxA' );
        WriteInteger( 'EstimatedSize', Round( TakeFileSize( Application.ExeName )/ 1024.0));
      end;
    CloseKey;
    Free;
  end;
end;
//======================================================================================================================
function GetProduct( par: TRegProduct): Variant;
  var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey( 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\' + Application.Title, True ) then
      case par of
        rpDate: Result    := ReadString( 'InstallDate' );
        rpVersion: Result := ReadString( 'DisplayVersion' );
      end;
    CloseKey;
    Free;
  end;
end;
//======================================================================================================================
end.
